<?php
/**
 * Saving the call progress table entries
 */
include("/usr/local/www/berogui/includes/Helper/Helper.php");

$exec_ajax = 1;
$invalid = array();

/* [CHECKING GET REQUEST] */
unset($_GET);

/* [CHECKING SESSION] */
$newTarget = '/app/berogui/index.php?m=Call_progress';
require_once('/usr/local/www/berogui/includes/session.php');
unset($newTarget);

/* [CHECKING POST REQUEST] */
unset($_POST['submit']);

$list_post = array( 
			'id_upd' => 'id', 'id_name' => 'group-name', 'events' => 'select', 'type' => 'select', 'resp' => 'select', 'sdp' => 'bool', 'resp_text' => 'config-option', 'chann_det' => 'select',
			'183_sdp' => 'bool', '180_sdp' => 'bool', '200_sdp' => 'bool'
		);

// TODO: gather the events into a unique file (ent_popup and ent_submit)
$sip_events = array("DIALPLAN_MATCH_FOUND", "183", "180", "200");
$isdn_events = array("NONE","PROCEEDING", "PROGRESS", "ALERTING", "CONNECT");
$fxo_events = array("DIALING_FINISHED", "DIALING_FINISHED_TIMER", "POLREV", "POLREV_TIMER", "ALERTING_STARTED", "ALERTING_STOPPED", "FAR_END_OFFHOOK_DETECT");

$list_options_post = array(	'events'	=> array_merge($sip_events, $isdn_events, $fxo_events),
				'chann_det'	=> array('no_channel', 'with_channel', 'without_inband', 'with_inband', 'any_state'),
				'resp'		=> array_merge($sip_events, $isdn_events, $fxo_events),
				'type'		=> array('nt', 'te', 'ntte')		
			   );

$_POST = Helper::sanitizePost($_POST, $list_post, $exec_ajax, $invalid, $list_options_post);

/* [EXECUTING AJAX] */
if (!$exec_ajax) {
	echo "<script>window.location='../../index.php?m=CallProgress&error=1&request={$invalid['request']}&checkor={$invalid['checkor']}&key={$invalid['key']}'</script>";
	exit(1);
}

chdir("../..");

	include "./includes/variables.php";
	include "./misc/database.php";
	require_once "./includes/isgwtelnet.php";
	$ba= new beroAri();
	require_once("./includes/lang.php");

        $id=sqlite_escape_string ($_POST['id_upd']);
        $id_name=sqlite_escape_string ($_POST['id_name']);
	$type=sqlite_escape_string ($_POST['type']);
	$resp=sqlite_escape_string ($_POST['resp']);
	if (isset($_POST['sdp']) && $resp!="none") $resp=$resp."_SDP";
	$resp_text=sqlite_escape_string ($_POST['resp_text']);
	$chann_det=sqlite_escape_string ($_POST['chann_det']);
	$events=$_POST['events'];
	$event="";
// TODO: remove this condition when the javascript validator will be added
	if (count($events)==0){
		echo "<script>alert('".CALL_PROGRESS_ENT_EVENT_MESS."'); window.history.back(); </script>";
		return;
	}
// end removing part
	for ($i=count($events)-1;$i>=0;$i--){
		if ($event=="") {
			$event.=$events[$i];
			if (isset($_POST[$events[$i]."_sdp"])) $event.="_SDP";
		}else{
			$event.=":".$events[$i];
			if (isset($_POST[$events[$i]."_sdp"])) $event.="_SDP";
		}
	}
	if ($_POST['id_upd']){
		$query_new = $ba->update("UPDATE callprogress_entries SET type='$type', sip_resp='$resp', resp_text='$resp_text', isdn_event='".sqlite_escape_string ($event)."',chann_det='$chann_det' WHERE id='$id'");
	}else{
		$query_new = $ba->insert_("INSERT INTO callprogress_entries (type, sip_resp, resp_text, isdn_event, chann_det, id_name)
								VALUES ('$type','$resp','$resp_text','".sqlite_escape_string ($event)."','$chann_det','$id_name')");
	}
        Helper::activate(1);
	if (!$ba->is_error()){
		echo "<script>window.location='../../index.php?m=CallProgress'</script>";

	}else{
		echo "<script>alert(".$ba->error().");</script>";
	}

?>
